﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_enable_menu_items
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cboState.Text = "AZ";
        }

        // Enable and disable items as appropriate.
        private void mnuEdit_DropDownOpening(object sender, EventArgs e)
        {
            EnableMenuItems();
        }
        private void ctxEdit_Opening(object sender, CancelEventArgs e)
        {
            EnableMenuItems();
        }

        private void EnableMenuItems()
        {
            if (ActiveControl is TextBox)
            {
                TextBox txt = ActiveControl as TextBox;
                mnuEditCopy.Enabled = (txt.SelectionLength > 0);
                mnuEditCut.Enabled = (txt.SelectionLength > 0);
                mnuEditPaste.Enabled = Clipboard.ContainsText();
            }
            else
            {
                // Disable all commands.
                mnuEditCopy.Enabled = false;
                mnuEditCut.Enabled = false;
                mnuEditPaste.Enabled = false;
            }

            ctxCopy.Enabled = mnuEditCopy.Enabled;
            ctxCut.Enabled = mnuEditCut.Enabled;
            ctxPaste.Enabled = mnuEditPaste.Enabled;
        }

        // Copy from the currently active TextBox.
        private void mnuEditCopy_Click(object sender, EventArgs e)
        {
            if (ActiveControl is TextBox)
            {
                TextBox txt = ActiveControl as TextBox;
                txt.Copy();
            }
        }

        // Cut from the currently active TextBox.
        private void mnuEditCut_Click(object sender, EventArgs e)
        {
            if (ActiveControl is TextBox)
            {
                TextBox txt = ActiveControl as TextBox;
                txt.Cut();
            }
        }

        // Cut into the currently active TextBox.
        private void mnuEditPaste_Click(object sender, EventArgs e)
        {
            if (ActiveControl is TextBox)
            {
                TextBox txt = ActiveControl as TextBox;
                txt.Paste();
            }
        }
    }
}
